package	jp.co.sds_corp.util.pooh.action;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

import javax.swing.JFrame;

import jp.co.sds_corp.util.pooh.menu.IMenuAction;
import jp.co.sds_corp.util.pooh.menu.SubMenuResource;
import jp.co.sds_corp.util.pooh.top.Toplevel;

/**
*
*/
public class ActHardcopy implements IMenuAction {
	Toplevel toplevel;

	public ActHardcopy(){}
	public void setParent(Toplevel _toplevel){ toplevel = _toplevel; }
	public void doAction(SubMenuResource sb, ActionEvent ae, int index) {
		PrintImage pImg = new PrintImage();
		PrinterJob pj = PrinterJob.getPrinterJob();
		PageFormat pf = (PageFormat)toplevel.getAttribute("PageFormat");
		if (pj.printDialog()) {
			if (pf != null) {
				pj.setPrintable(pImg, pf);
			} else {
				pj.setPrintable(pImg, pj.defaultPage());
			}
			try {
				pj.print();
			} catch (PrinterException pe) {
				pe.printStackTrace();
			}
		}
	}

	public class PrintImage implements Printable {
		public PrintImage(){}
		public int print(Graphics g, PageFormat pf, int index) {
			if (index >= 1) { return Printable.NO_SUCH_PAGE; }
			double SCALE_X = pf.getImageableWidth() 
						   / (double)((JFrame)toplevel.getFrame()).getWidth();
			double SCALE_Y = pf.getImageableHeight() 
						   / (double)((JFrame)toplevel.getFrame()).getHeight();

			System.out.println(pf.getOrientation());

			g.translate((int)pf.getImageableX(), (int)pf.getImageableY());
			((Graphics2D)g).transform(
					java.awt.geom.AffineTransform.getScaleInstance(SCALE_X, SCALE_Y));
			((JFrame)toplevel.getFrame()).paint(g);
			return Printable.PAGE_EXISTS;
		}
	}
}
