package	jp.co.sds_corp.util.pooh.menu;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import jp.co.sds_corp.util.pooh.simple.SimpleMenuBar;
import jp.co.sds_corp.util.pooh.top.Toplevel;

public class MenuManager {
	Map menuMap = new HashMap();
	Toplevel toplevel = null;
	public MenuManager(Toplevel _toplevel) {toplevel = _toplevel;}
	public void add(String fn, Object frame) { menuMap.put(fn, frame); }
	public void clear() { menuMap.clear(); }
	public Object get(String fn) { return menuMap.get(fn); }

	public Object createMenu(String fn) throws Exception {
		MenuParser parser = new MenuParser(toplevel);
		MenuResource menuResource = parser.loadResource(fn);
		menuResource.setMenuBar(new SimpleMenuBar(toplevel, menuResource));
		add(menuResource.getMenubar_name(), menuResource);	
		return menuResource;
	}

	public Object createMenu(String fn, String path) throws Exception {
		MenuParser parser = new MenuParser(toplevel);
		MenuResource menuResource = parser.loadResource(fn, path);
		menuResource.setMenuBar(new SimpleMenuBar(toplevel, menuResource));
		add(menuResource.getMenubar_name(), menuResource);	
		return menuResource;
	}

	public Object createMenu(String fn, String path, String resType) throws Exception {
		MenuParser parser = new MenuParser(toplevel);
		MenuResource menuResource = parser.loadResource(fn, path, resType);
		menuResource.setMenuBar(new SimpleMenuBar(toplevel, menuResource));
		add(menuResource.getMenubar_name(), menuResource);	
		return menuResource;
	}

	public void createMenu(MenuResource menuResource) throws Exception {
		menuResource.setMenuBar(new SimpleMenuBar(toplevel, menuResource));
	}

	public void removeAll() { menuMap.clear(); }
	public void remove(String fn) { menuMap.remove(fn); }
	public void loadResourceAll(String path, String resType) throws Exception {
		MenuParser parser = new MenuParser(toplevel);
		MenuResource [] mrs = parser.loadResourceAll(path, resType);
		for (int i=0; i<mrs.length; i++)
			add(mrs[i].getMenubar_name(), mrs[i]);
		return;
	}

	public boolean isAlive(String fn) { return (get(fn) != null) ? true : false; }
	public Iterator iterator() { return menuMap.values().iterator(); }
	public void closed() {
		Iterator iterator = menuMap.values().iterator();
		while (iterator.hasNext()) {
			MenuResource info = (MenuResource)iterator.next();
			SimpleMenuBar menu = info.getMenuBar();
			menu.closed();
		}
	}
}
