package	jp.co.sds_corp.util.pooh.simple;

import java.awt.Component;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;

import jp.co.sds_corp.util.pooh.dialog.DialogResource;
import jp.co.sds_corp.util.pooh.dialog.SimpleDialogListener;
import jp.co.sds_corp.util.pooh.frame.FrameResource;
import jp.co.sds_corp.util.pooh.pane.ChildPane;
import jp.co.sds_corp.util.pooh.pane.CustButton;
import jp.co.sds_corp.util.pooh.top.Toplevel;

public abstract class SimplePanel extends JPanel implements SimpleDialogListener, ChildPane {

	protected JFrame  frame = null;
	protected JDialog dialog = null;
	protected JInternalFrame iframe;
	protected CustButton custbutton;
	protected int parent_frame;
	protected Toplevel toplevel;
	protected DialogResource dialogResource;
	protected FrameResource  frameResource;

	private static final int PARENT_FRAME         = 0;
	private static final int PARENT_DIALOG        = 1;
	private static final int PARENT_INTERNALFRAME = 2;

	public void setParent(Toplevel _toplevel, JDialog _dialog
			, CustButton _custbutton, DialogResource _dialogResource) { 
		toplevel      = _toplevel;
		dialog        = _dialog;
		custbutton    = _custbutton;
		parent_frame  = PARENT_DIALOG;
		dialogResource = _dialogResource;
		custbutton.setListener(this);
		custbutton.setButtonFace(0, "OK", KeyEvent.VK_O);
	}

	public void getButtons() { custbutton.getButtons(); }

	public void setButtonFace(int idx, String name, int m) {
		custbutton.setButtonFace(idx, name, m);
	}

	public void setDefaultButton(int idx) {
		custbutton.setDefaultButton(idx);
	}

	public void setButton_id(int idx, int id) {
		custbutton.setButton_id(idx, id);
	}

	public void setButtonEnabled(int idx, boolean enable) {
		switch (parent_frame) {
			case PARENT_FRAME: break;
			case PARENT_DIALOG:
				custbutton.setEnabled(idx, enable);
				break;
			case PARENT_INTERNALFRAME: break;
		}
	}

	public void setMenuBar(SimpleMenuBar bar) {
		switch (parent_frame) {
			case PARENT_FRAME: break;
			case PARENT_DIALOG: break;
			case PARENT_INTERNALFRAME:
				iframe.setJMenuBar(bar);
				break;
		}
	}

	public boolean isFrame()         { return parent_frame==PARENT_FRAME; }
	public boolean isInternalFrame() { return parent_frame==PARENT_INTERNALFRAME; }
	public boolean isDialog()        { return parent_frame==PARENT_DIALOG; }
	public int getParentType()   { return parent_frame; }

	public Object getResource() {
		return (parent_frame==PARENT_DIALOG) ? (Object)dialogResource : (Object)frameResource;
	}

	public void setParent(Toplevel _toplevel, JInternalFrame _iframe, FrameResource request) {
		toplevel = _toplevel;
		iframe   = _iframe;
		parent_frame = PARENT_INTERNALFRAME;
		frameResource = request;
	}

	public void setParent(JFrame _frame) {
		frame = _frame;
		parent_frame = PARENT_FRAME;
	}

	public abstract boolean createPane();
	public void doAction(int idx) {
		((SimpleDialog)dialog).setAction(custbutton.getButton_id(idx));
		setVisible(false);
		custbutton.closed();
	}
	public void doSystemBtnClose(WindowEvent e) {}

	public Component getParentComponent() {
		switch (parent_frame) {
			case PARENT_FRAME: return frame;
			case PARENT_DIALOG: return dialog;
			case PARENT_INTERNALFRAME: return iframe;
		}
		return null;
	}

	public void setTitle(String title) {
		switch (parent_frame) {
			case PARENT_FRAME:
				frame.setTitle(title);
				break;
			case PARENT_DIALOG:
				dialog.setTitle(title);
				break;
			case PARENT_INTERNALFRAME:
				iframe.setTitle(title);
				break;
		}
	}

	public void setVisible(boolean b) {
		switch (parent_frame) {
			case PARENT_FRAME:
				frame.setVisible(b);
				break;
			case PARENT_DIALOG:
				if (!b)
					dialog.hide();
				else
					dialog.show();
				break;
			case PARENT_INTERNALFRAME:
				iframe.setVisible(b);
				break;
		}
	}
	public abstract void closed();
	public void setEnabled(boolean enable) {}
}
