package jp.co.sds_corp.util.pooh.simple;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComponent;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;

import jp.co.sds_corp.util.pooh.frame.FrameResource;
import jp.co.sds_corp.util.pooh.menu.RootMenuResource;
import jp.co.sds_corp.util.pooh.menu.SubMenuResource;
public class SimplePopupMenu extends JPopupMenu implements ActionListener {
	private int selectedRow = -1;
	private String name          = null;
	public ActionListener actListener = null;
	public Map items = new HashMap();

	public SimplePopupMenu(ActionListener l, Object[][] m) {
		for (int i=0; i<m.length; i++) {
			JMenuItem menuItem = new JMenuItem((String)m[i][0], ((Integer)m[i][1]).intValue());
			menuItem.addActionListener(l);
			add(menuItem);
		}
	}

	public SimplePopupMenu(ActionListener l, RootMenuResource _res) {
		createPopupMenu(l, _res.getName(), this, null, null, _res);
		actListener = l;
	}

	public SimplePopupMenu(ActionListener l, FrameResource parser) {
		createPopupMenu(l, parser.getKeyMap().getName(), this, null, null, parser.getKeyMap());
		actListener = l;
	}

	public void createPopupMenu(ActionListener l, String key, SimplePopupMenu _menu,
				SimplePopSubMenu _sub, ButtonGroup _group, RootMenuResource _parser) {
		Iterator iterator = _parser.iterator(key);
		while (iterator.hasNext()) {
			SubMenuResource info = (SubMenuResource)iterator.next();
			switch( info.getType()) {
				case SubMenuResource.MENU_NORMAL:
					JMenuItem menuItem = new JMenuItem(info.getName(), info.getMnemonic());
					menuItem.setEnabled(info.getEnabled());
					if (_menu != null) {
						_menu.add(menuItem);
						items.put(info.getName(), info);
						menuItem.addActionListener(_menu);
					} else {
						_sub.add(menuItem);
						menuItem.addActionListener(_sub);
					}
					info.setThis(menuItem);
					break;

				case SubMenuResource.MENU_SEPARATOR:
					_menu.addSeparator();
					break;

				case SubMenuResource.MENU_MENU:
					SimplePopSubMenu m1 = new SimplePopSubMenu(info.getName(), info);
					createPopupMenu(l, info.getName(), null, m1, null, _parser);
					if (_menu != null) {
						_menu.add(m1);
					} else {
						_sub.add(m1);
					}
					break;

				case SubMenuResource.MENU_GROUP:
					ButtonGroup group = new ButtonGroup();
					createPopupMenu(l, info.getName(), _menu, _sub, group, _parser);
					break;

				case SubMenuResource.MENU_CHECK:
					JCheckBoxMenuItem cbMenuItem = new JCheckBoxMenuItem(info.getName());
					cbMenuItem.setSelected(info.getSelected());
					cbMenuItem.setMnemonic(info.getMnemonic());
					cbMenuItem.setEnabled(info.getEnabled());
					if (_menu != null) {
						_menu.add(cbMenuItem);
						items.put(info.getName(), info);
						cbMenuItem.addActionListener(_menu);
					} else {
						_sub.add(cbMenuItem);
						cbMenuItem.addActionListener(_sub);
					}
					info.setThis(cbMenuItem);
					break;

				case SubMenuResource.MENU_RADIO:
					JRadioButtonMenuItem rbMenuItem = new JRadioButtonMenuItem(info.getName());
					rbMenuItem.setSelected(info.getSelected());
					rbMenuItem.setMnemonic(info.getMnemonic());
					rbMenuItem.setEnabled(info.getEnabled());
					if (_group != null) { _group.add(rbMenuItem); }
					if (_menu != null) {
						_menu.add(rbMenuItem);
						items.put(info.getName(), info);
						rbMenuItem.addActionListener(_menu);
					} else {
						_sub.add(rbMenuItem);
						rbMenuItem.addActionListener(_sub);
					}
					info.setThis(rbMenuItem);
					break;
            }
        }
	}

	public void showpopup(MouseEvent e) {
		JComponent component = (JComponent)e.getComponent();
		if (e.isPopupTrigger()) {
			int w = e.getX() + getWidth();
			int x = (w > component.getWidth()) ? e.getX() - getWidth() : e.getX();
			show(component, x, e.getY());
		}
	}

	public void showpopup(Component component, int x, int y, int _selectedRow) {
		show(component, x, y);
	}

	public void setSelectedRow(int _selectedRow) { selectedRow = _selectedRow; }
	public int getSelectedRow() { return selectedRow; }

	protected class SimplePopSubMenu extends JMenu implements ActionListener {
		public SubMenuResource info;
		public Object getListener() { return info.getListener(); }
		public int getListener_type() { return info.getListener_type(); }
		public SimplePopSubMenu(String _name, SubMenuResource _info) {
			super(_info.getName());
			setMnemonic(_info.getMnemonic());
			setEnabled(_info.getEnabled());
			info = _info;
		}
		public void actionPerformed(ActionEvent e) {
			((SimplePopup)actListener).doAction(info);
		}
	}

	public void actionPerformed(ActionEvent e) {
		SubMenuResource info = (SubMenuResource)items.get(((JMenuItem)e.getSource()).getText());
		((SimplePopup)actListener).doAction(info);
	}
}
