package jp.co.sds_corp.util.pooh.top;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;


/*
 * @deprecated Class FastHashMap is deprecated
 */

public class FastHashMap extends HashMap {

    public FastHashMap() {
        map = null;
        fast = false;
        map = new HashMap();
    }

    public FastHashMap(int capacity) {
        map = null;
        fast = false;
        map = new HashMap(capacity);
    }

    public FastHashMap(int capacity, float factor) {
        map = null;
        fast = false;
        map = new HashMap(capacity, factor);
    }

    public FastHashMap(Map map) {
        this.map = null;
        fast = false;
        this.map = new HashMap(map);
    }

    public boolean getFast() { return fast; }

    public void setFast(boolean fast) { this.fast = fast; }

    public void clear() {
        if(fast) {
            synchronized(this) {
                HashMap temp = (HashMap)map.clone();
                temp.clear();
                map = temp;
            }
		} else {
            synchronized(map) {
                map.clear();
            }
		}
    }

    public Object clone() {
        FastHashMap results = null;
        if(fast)
            results = new FastHashMap(map);
        else
            synchronized(map) {
                results = new FastHashMap(map);
            }
        results.setFast(getFast());
        return results;
    }

    public boolean containsKey(Object key) {
        if(fast)
            return map.containsKey(key);
        boolean flag;
        synchronized(map) {
            flag = map.containsKey(key);
        }
        return flag;
    }

    public boolean containsValue(Object value) {
        if(fast)
            return map.containsValue(value);
        boolean flag;
        synchronized(map) {
            flag = map.containsValue(value);
        }
        return flag;
    }

    public Set entrySet() {
        if(fast)
            return map.entrySet();
        Set set;
        synchronized(map) {
            set = map.entrySet();
        }
        return set;
    }

    public boolean equals(Object o) {
        if(o == this)
            return true;
        if(!(o instanceof Map))
            return false;
        Map mo = (Map)o;
        if(fast) {
            if(mo.size() != map.size())
                return false;
            for(Iterator i = map.entrySet().iterator(); i.hasNext();) {
                java.util.Map.Entry e = (java.util.Map.Entry)i.next();
                Object key = e.getKey();
                Object value = e.getValue();
                if(value == null) {
                    if(mo.get(key) != null || !mo.containsKey(key))
                        return false;
                } else
                if(!value.equals(mo.get(key)))
                    return false;
            }

            return true;
        }
        boolean flag1;
        synchronized(map) {
            if(mo.size() != map.size()) {
                boolean flag = false;
                return flag;
            }
            for(Iterator i = map.entrySet().iterator(); i.hasNext();) {
                java.util.Map.Entry e = (java.util.Map.Entry)i.next();
                Object key = e.getKey();
                Object value = e.getValue();
                if(value == null) {
                    if(mo.get(key) != null || !mo.containsKey(key)) {
                        boolean flag2 = false;
                        return flag2;
                    }
                } else if(!value.equals(mo.get(key))) {
                    boolean flag3 = false;
                    return flag3;
                }
            }

            flag1 = true;
        }
        return flag1;
    }

    public Object get(Object key) {
        if(fast)
            return map.get(key);
        Object obj;
        synchronized(map) {
            obj = map.get(key);
        }
        return obj;
    }

    public int hashCode() {
        if(fast) {
            int h = 0;
            for(Iterator i = map.entrySet().iterator(); i.hasNext();)
                h += i.next().hashCode();

            return h;
        }
        int j;
        synchronized(map) {
            int h = 0;
            for(Iterator i = map.entrySet().iterator(); i.hasNext();)
                h += i.next().hashCode();

            j = h;
        }
        return j;
    }

    public boolean isEmpty() {
        if(fast)
            return map.isEmpty();
        boolean flag;
        synchronized(map) {
            flag = map.isEmpty();
        }
        return flag;
    }

    public Set keySet() {
        if(fast)
            return map.keySet();
        Set set;
        synchronized(map) {
            set = map.keySet();
        }
        return set;
    }

    public Object put(Object key, Object value) {
        if(fast) {
            Object obj1;
            synchronized(this) {
                HashMap temp = (HashMap)map.clone();
                Object result = temp.put(key, value);
                map = temp;
                obj1 = result;
            }
            return obj1;
        }
        Object obj;
        synchronized(map) {
            obj = map.put(key, value);
        }
        return obj;
    }

    public void putAll(Map in) {
        if(fast)
            synchronized(this) {
                HashMap temp = (HashMap)map.clone();
                temp.putAll(in);
                map = temp;
            }
        else
            synchronized(map) {
                map.putAll(in);
            }
    }

    public Object remove(Object key) {
        if(fast) {
            Object obj1;
            synchronized(this) {
                HashMap temp = (HashMap)map.clone();
                Object result = temp.remove(key);
                map = temp;
                obj1 = result;
            }
            return obj1;
        }
        Object obj;
        synchronized(map) {
            obj = map.remove(key);
        }
        return obj;
    }

    public int size() {
        if(fast)
            return map.size();
        int i;
        synchronized(map) {
            i = map.size();
        }
        return i;
    }

    public Collection values() {
        if(fast)
            return map.values();
        Collection collection;
        synchronized(map) {
            collection = map.values();
        }
        return collection;
    }

    protected HashMap map;
    protected boolean fast;
}
