package	jp.co.sds_corp.util.window;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.net.URL;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.InputMap;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;

public class WindowUtility
{
	public static void addGridBag( JPanel pnl, Component c,
			int x, int y, int w, int h ) {
		GridBagLayout gbl = (GridBagLayout )pnl.getLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gbl.setConstraints( c, gbc );
		pnl.add( c );
	}

	public static void center( Component parent, Component c ) {
		Rectangle rect = SwingUtilities.getRoot( parent ).getBounds();
		Dimension d = c.getSize();
		int x = (int )(rect.getX() + rect.getWidth() / 2 - d.getWidth() / 2);
		if ( x < 0 ) {
			x = 0;
		}
		int y = (int )(rect.getY() + rect.getHeight() / 2 - d.getHeight() / 2);
		if ( y < 0 ) {
			y = 0;
		}
		c.setLocation( x, y );
	}

	public static void setHideOnEscape( JDialog dialog ) {
		EscapeAction escAct = new EscapeAction( "ESCAPE", dialog );
		KeyStroke escape
			= KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE, 0, false );
		InputMap imap = dialog.getRootPane()
						.getInputMap( JComponent.WHEN_IN_FOCUSED_WINDOW );
		imap.put( escape, "ESCAPE");
		dialog.getRootPane().getActionMap().put( "ESCAPE", escAct );
	}

	public static void removeTableEscape( JTable table ) {
		KeyStroke escape
			= KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE, 0, false );
		table.getInputMap( JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT )
				.getParent().remove( escape );
	}

	public static void setButtonIcon( Object caller, JButton btn, String img1 ) {
		setButtonIcon( caller, btn, img1, null );
	}
	public static void setButtonIcon( Object caller, JButton btn, String img1, String img2 ) {
		URL imgUrl;
		ImageIcon icon;

		imgUrl = caller.getClass().getResource( img1 );
		icon = new ImageIcon( imgUrl );
		btn.setIcon( icon );
		if ( img2 != null ) {
			imgUrl = caller.getClass().getResource( img2 );
			icon = new ImageIcon( imgUrl );
			btn.setDisabledIcon( icon );
		}
	}

}
class EscapeAction extends AbstractAction {
	JDialog dialog;
	EscapeAction( String name, JDialog dialog ) {
		super( name );
		this.dialog = dialog;
	}
	public void actionPerformed(ActionEvent evt) {
		dialog.hide();
	}
}

